*:*********************************************************************
*:
*:        Program: EDTQUEUE.PRG
*:
*:         System: Inorder -=- Point of Sale
*:         Author: Phil Barnett / Mark DeVuyst
*:      Copyright (c) 1990, Phil Barnett
*:  Last modified: 08/29/90     23:03
*:
*:  Procs & Fncts: db_func
*:
*:      Called by: TABLES.PRG                    
*:
*:          Calls: TITLEBOX.PRG
*:               : db_func        (procedure in EDTQUEUE.PRG, called from Dbedit())
*:
*:      Documented 09/04/90 at 00:55                SNAP!  version 4.02
*:*********************************************************************
CLEAR
use lblprnt
PRIVATE dataset5[4],names[4],picts[4]
dataset5[1] = FIELDNAME(1)
dataset5[2] = FIELDNAME(2)
dataset5[3] = FIELDNAME(3)
dataset5[4] = FIELDNAME(4)
picts[1] = '9999'
picts[2] = '@!'
picts[3] = ''
picts[4] = '999999.99'
names[1] = 'Quantity'
names[2] = 'Part Number'
names[3] = 'Description'
names[4] = 'Price'
DRAWBOX(7,19,SPACE(69))
SET COLOR TO (mcolor6)
CNT('  ' + CHR(27) + ' ' + CHR(24) + ' ' + CHR(25) + ' ' + CHR(26)  + '  PgUp   PgDn   (E)dit   (A)dd   (D)elete  (P)rint  ',19)
SET COLOR TO (mcolor11)
Dbedit(7,5,17,73,dataset5,"db_func",picts,names)
SET COLOR TO (mcolor1)
RETURN


*!*********************************************************************
*!
*!      Procedure: db_func
*!
*!         Set by: EDTQUEUE.PRG                  
*!
*!          Calls: UPDATED()      (function  in ?)
*!               : ADD_REC()      (function  in LOCKS.PRG)
*!               : REC_LOCK()     (function  in LOCKS.PRG)
*!               : SET_IBM        (procedure in BARPROCS.PRG)
*!               : CNVT_CODE      (procedure in BARPROCS.PRG)
*!               : BAR_CODE()     (function  in BARPROCS.PRG)
*!
*!           Uses: LBLPRNT.DBF    
*!
*!*********************************************************************
FUNCTION db_func

PARAMETERS pf1,pf2

KEY = LASTKEY()

DO CASE
CASE pf1 = 0
  RETURN(1)
CASE pf1 = 3
  mquantity = 0
  mpartn = SPACE(20)
  mdesc = SPACE(20)
  mprice = 0
  @ 18,06 GET mquantity PICTURE '9999'
  @ 18,17 GET mpartn    PICTURE '@!'
  @ 18,40 GET mdesc
  @ 18,63 GET mprice    PICTURE '999999.99'
  SET Cursor (.T.)
  READ
  SET Cursor (.F.)
  @ 18,04 CLEAR TO 18,74
  IF LASTKEY() = 27
    RETURN(0)
  ENDIF
  IF updated()
    IF add_rec(1)
      REPLACE quantity WITH mquantity
      REPLACE partn WITH mpartn
      REPLACE DESC WITH mdesc
      REPLACE price WITH mprice
    ENDIF
    COMMIT
    UNLOCK
    GO TOP
    RETURN(2)
  ENDIF
CASE KEY = 5 .AND. pf1 = 1
  RETURN(1)
CASE KEY = 24 .AND. pf1 = 2
  RETURN(1)
CASE KEY = 27
  RETURN(0)
CASE KEY = 101 .OR. KEY = 69  && Edit
  IF rec_lock(1)
    temp = FIELDNAME(pf2)
    @ ROW(),COL() GET &temp
    SET Cursor (.T.)
    READ
    SET Cursor (.F.)
    COMMIT
    UNLOCK
    RETURN(1)
  ENDIF
CASE KEY = 65 .OR. KEY = 97  && Add
  mquantity = 0
  mpartn = SPACE(20)
  mdesc = SPACE(20)
  mprice = 0
  @ 18,06 GET mquantity PICTURE '9999'
  @ 18,17 GET mpartn    PICTURE '@!'
  @ 18,40 GET mdesc
  @ 18,63 GET mprice    PICTURE '999999.99'
  SET Cursor (.T.)
  READ
  SET Cursor (.F.)
  @ 18,04 CLEAR TO 18,74
  IF LASTKEY() = 27
    RETURN(2)
  ENDIF
  IF updated()
    IF add_rec(1)
      REPLACE quantity WITH mquantity
      REPLACE partn WITH mpartn
      REPLACE DESC WITH mdesc
      REPLACE price WITH mprice
    ENDIF
    COMMIT
    UNLOCK
    GO TOP
    RETURN(2)
  ENDIF
CASE KEY = 68 .OR. KEY = 100  && Delete
  IF rec_lock(1)
    SET COLOR TO (mcolor6)
    CNT('  Are you sure you want to delete this record?    (Y/N)  ',24)
    yn = ' '
    DO WHILE !yn$'YN'
      yn=UPPER(CHR(INKEY(0)))
    ENDDO
    IF yn = 'Y'
      DELETE
    ENDIF
    SET COLOR TO (mcolor1)
    @ 24,0
    SET COLOR TO (mcolor11)
    COMMIT
    UNLOCK
    RETURN(2)
  ENDIF
CASE KEY = 80 .OR. KEY = 112   && Print the Job
  lblscrn = SAVESCREEN(0,0,24,79)
  SET COLOR TO (mcolor1)
  CLEAR
  MESSAGE('Put the labels into the printer and press any key',12)
  KEY = INKEY(0)
  DO WHILE .T.
    SET COLOR TO (mcolor1)
    CLEAR
    MESSAGE('(A)lign --- (P)rint --- <Esc>',12)
    SET COLOR TO (mcolor1)
    SET CONSOLE (.F.)
    SET PRINT (.T.)
    KEY = INKEY(0)  && do NOT change this line....
    IF LASTKEY() = 27
      CLEAR
      EXIT
    ENDIF
    option  = UPPER(CHR(KEY))
    DO CASE
    CASE option = 'A'
      ? 'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX'
      ? 'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX'
      ? 'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX'
      ? 'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX'
      ? 'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX'
      ?
    CASE option = 'P'
      set_ibm()
      cnvt_code()
      GO TOP
      DO WHILE !EOF()
        x_text = "*" + Alltrim(partn) + "*"
        m_code=Alltrim(partn)
        chklen = LEN(m_code)
        thischar = 1
        abortlab = .F.
        DO WHILE thischar <= chklen
          chkchar = SUBSTR(m_code,thischar,1)
          IF ! chkchar $  "1234567890ABCDEFGHIJKLMNOPQRSTUVWXYZ-. *$/ + %"
            SET PRINT (.T.)
            ?
            ? 'Illegal Character: ' + chkchar
            ? m_code
            ? 'This label is Aborted'
            ?
            ?
            SET PRINT (.F.)
            abortlab = .T.
            EXIT
          ENDIF
          thischar = thischar + 1
        ENDDO
        IF abortlab
          SKIP
          LOOP
        ENDIF
        mdesc = Alltrim(DESC)
        p_many = quantity
        x_tm = 1
        SET DEVICE TO PRINT
        DO WHILE x_tm <= p_many
          @ PROW()   ,0 SAY CHR(27) + CHR(51) + CHR(36)
          @ PROW() + 2 ,0 SAY bar_code(x_text)
          @ PROW()     ,0 SAY CHR(15) + m_code + SPACE(2) + mdesc
          @ PROW() + 1 ,0 SAY CHR(18) + '$' + Alltrim(STR(price,9,2)) + CHR(27) + CHR(51) + CHR(34) && set line feed to 2/216
          @ PROW() + 1 ,0 SAY ""
          x_tm=x_tm + 1
        ENDDO
        SKIP
      ENDDO
      SET DEVICE TO SCREEN
      ??codeclear
      EJECT
      SET PRINT (.F.)
      SET COLOR TO (mcolor1)
      CLEAR
      MESSAGE(' Label Printing Program ',2)
      SET COLOR TO (mcolor1)
      ans = 'Y'
      CNT(' Do you wish to Erase the Data File?  (Y/N) ',12)
      @ 14,39 GET ans PICTURE '!' VALID ans $ 'YN'
      SET Cursor (.T.)
      READ
      SET Cursor (.F.)
      IF ans = 'Y'
        SELECT lblprnt
        USE lblprnt EXCLUSIVE
        IF !Neterr()
          ZAP
        ELSE
          CLEAR
          MESSAGE('Label file cannot be Erased while others are using it!',12)
          INKEY(0)
        ENDIF
        USE lblprnt
      ENDIF
    OTHERWISE
    ENDCASE
  ENDDO
  SET COLOR TO (mcolor11)
  RESTSCREEN(0,0,24,79,lblscrn)
  RETURN(1)
OTHERWISE
  RETURN(1)
ENDCASE
*: EOF: EDTQUEUE.PRG
